varying highp vec4 xlv_TEXCOORD3;
varying highp vec4 xlv_TEXCOORD2;
varying highp vec4 xlv_COLOR0;
varying highp vec4 xlv_TEXCOORD1;
varying highp vec4 xlv_TEXCOORD0;
attribute vec2 uv0;
attribute vec3 normal;
attribute vec4 vertex;
uniform highp mat4 WorldMatrix;
uniform highp vec3 FadeDistance;
uniform highp vec4 LightConfig1;
uniform highp vec4 LightConfig0;
uniform highp vec4 FogParams;
uniform highp float WaterSintime;
uniform highp float WaterTimeframe;
uniform highp vec3 Lamp1Color;
uniform highp vec3 Lamp0Color;
uniform highp vec3 Lamp0Dir;
uniform highp mat4 ViewProjection;
uniform highp vec3 CameraPosition;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_1.zw = vec2(0.0, 0.0);
  tmpvar_2.zw = vec2(0.0, 0.0);
  highp vec3 tmpvar_3;
  tmpvar_3 = (normal / 127.0);
  highp vec2 tmpvar_4;
  tmpvar_4 = (uv0 / 1024.0);
  highp vec3 tmpvar_5;
  tmpvar_5 = (WorldMatrix * vertex).xyz;
  highp vec3 tmpvar_6;
  tmpvar_6 = normalize(tmpvar_3);
  highp float tmpvar_7;
  tmpvar_7 = dot (tmpvar_6, -(Lamp0Dir));
  highp vec4 tmpvar_8;
  tmpvar_8.w = 1.0;
  tmpvar_8.xyz = tmpvar_5;
  highp vec4 tmpvar_9;
  tmpvar_9 = (ViewProjection * tmpvar_8);
  highp vec4 tmpvar_10;
  tmpvar_10.xw = vec2(1.0, 1.0);
  tmpvar_10.y = max (0.0, tmpvar_7);
  tmpvar_10.z = pow ((max (0.0, dot (normalize((-(Lamp0Dir) + normalize((CameraPosition - tmpvar_5)))), tmpvar_6)) * float((tmpvar_7 >= 0.0))), 25.0);
  highp vec4 tmpvar_11;
  tmpvar_11.xyz = ((clamp (tmpvar_7, 0.0, 1.0) * Lamp0Color) + (max (-(tmpvar_7), 0.0) * Lamp1Color));
  tmpvar_11.w = (0.4 * tmpvar_10.z);
  highp vec4 tmpvar_12;
  tmpvar_12.xyz = (((tmpvar_5 + (tmpvar_6 * 6.0)).yxz * LightConfig0.xyz) + LightConfig1.xyz);
  tmpvar_12.w = ((FogParams.z - tmpvar_9.w) * FogParams.w);
  highp vec4 tmpvar_13;
  tmpvar_13.xyz = tmpvar_5;
  tmpvar_13.w = (tmpvar_9.w * FadeDistance.y);
  highp float tmpvar_14;
  tmpvar_14 = floor(abs(dot (tmpvar_3, vec3(1.0, 1.0, 1.0))));
  highp float tmpvar_15;
  tmpvar_15 = min (1.0, tmpvar_14);
  highp float tmpvar_16;
  tmpvar_16 = (1.0 - tmpvar_15);
  highp float tmpvar_17;
  tmpvar_17 = (((tmpvar_15 * WaterTimeframe) * tmpvar_14) + ((tmpvar_16 * 0.125) * WaterSintime));
  highp vec2 tmpvar_18;
  tmpvar_18.x = tmpvar_16;
  tmpvar_18.y = tmpvar_15;
  tmpvar_1.xy = (tmpvar_4 - ((tmpvar_18 * 3.0) * tmpvar_17));
  highp vec2 tmpvar_19;
  tmpvar_19.x = tmpvar_4.x;
  tmpvar_19.y = (tmpvar_4.y - (4.0 * tmpvar_17));
  tmpvar_2.xy = tmpvar_19;
  gl_Position = tmpvar_9;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_2;
  xlv_COLOR0 = tmpvar_11;
  xlv_TEXCOORD2 = tmpvar_12;
  xlv_TEXCOORD3 = tmpvar_13;
}

